diff --git a/src/main/java/net/minecraft/core/block/BlockFluid.java b/src/main/java/net/minecraft/core/block/FluidBlock.java
similarity index 80%
rename from src/main/java/net/minecraft/core/block/BlockFluid.java
rename to src/main/java/net/minecraft/core/block/FluidBlock.java
index 45cf867fc..45924b8bd 100644
--- a/src/main/java/net/minecraft/core/block/BlockFluid.java
+++ b/src/main/java/net/minecraft/core/block/FluidBlock.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
@@ -8,18 +8,18 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
-public abstract class BlockFluid extends Block
+public abstract class FluidBlock extends Block
 {
 
-	public BlockFluid(String key, int id, Material material)
+	public FluidBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         setTicking(true);
     }
@@ -61,7 +61,7 @@ public abstract class BlockFluid extends Block
     }
 
     @Override
-    public boolean renderAsNormalBlock()
+    public boolean isCubeShaped()
     {
         return false;
     }
@@ -106,9 +106,9 @@ public abstract class BlockFluid extends Block
         return null;
     }
 
-    private Vec3d getFlow(WorldSource world, int x, int y, int z)
+    private Vec3 getFlow(WorldSource world, int x, int y, int z)
     {
-        Vec3d result = Vec3d.createVector(0.0D, 0.0D, 0.0D);
+        Vec3 result = Vec3.getTempVec3(0.0D, 0.0D, 0.0D);
         int depthLocal = getRenderedDepth(world, x, y, z);
         for(int i = 0; i < 4; i++)
         {
@@ -142,14 +142,14 @@ public abstract class BlockFluid extends Block
                 if(depthCheck >= 0)
                 {
                     int mult = depthCheck - (depthLocal - 8);
-                    result = result.addVector((checkX - x) * mult, (checkY - y) * mult, (checkZ - z) * mult);
+                    result = result.add((checkX - x) * mult, (checkY - y) * mult, (checkZ - z) * mult);
                 }
                 continue;
             }
             else
             {
                 int mult = depthCheck - depthLocal;
-                result = result.addVector((checkX - x) * mult, (checkY - y) * mult, (checkZ - z) * mult);
+                result = result.add((checkX - x) * mult, (checkY - y) * mult, (checkZ - z) * mult);
             }
         }
         result = result.normalize();
@@ -157,17 +157,17 @@ public abstract class BlockFluid extends Block
     }
 
     @Override
-    public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3d entityVelocity)
+    public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3 entityVelocity)
     {
         if (entity.noPhysics) return;
-        Vec3d flowVector = getFlow(world, x, y, z);
-        entityVelocity.xCoord += flowVector.xCoord;
-        entityVelocity.yCoord += flowVector.yCoord;
-        entityVelocity.zCoord += flowVector.zCoord;
+        Vec3 flowVector = getFlow(world, x, y, z);
+        entityVelocity.x += flowVector.x;
+        entityVelocity.y += flowVector.y;
+        entityVelocity.z += flowVector.z;
     }
 
     @Override
-    public int tickRate()
+    public int tickDelay()
     {
         if(blockMaterial == Material.water)
         {
@@ -191,13 +191,13 @@ public abstract class BlockFluid extends Block
     }
 
     @Override
-    public int getRenderBlockPass()
+    public int getRenderLayer()
     {
         return blockMaterial != Material.water ? 0 : 1;
     }
 
     @Override
-    public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+    public void animationTick(World world, int x, int y, int z, Random rand)
     {
         if(blockMaterial == Material.water && rand.nextInt(64) == 0)
         {
@@ -218,26 +218,26 @@ public abstract class BlockFluid extends Block
 
     public static double getSlopeAngle(WorldSource blockAccess, int x, int y, int z, Material material)
     {
-        Vec3d vec3d = null;
+        Vec3 vec3 = null;
         if(material == Material.water)
         {
-            vec3d = ((BlockFluid)Block.fluidWaterFlowing).getFlow(blockAccess, x, y, z);
+            vec3 = ((FluidBlock)Blocks.FLUID_WATER_FLOWING).getFlow(blockAccess, x, y, z);
         }
         if(material == Material.lava)
         {
-            vec3d = ((BlockFluid)Block.fluidLavaFlowing).getFlow(blockAccess, x, y, z);
+            vec3 = ((FluidBlock)Blocks.FLUID_LAVA_FLOWING).getFlow(blockAccess, x, y, z);
         }
-        if(vec3d.xCoord == 0.0D && vec3d.zCoord == 0.0D)
+        if(vec3 == null ||(vec3.x == 0.0D && vec3.z == 0.0D))
         {
             return -1000D;
         } else
         {
-            return Math.atan2(vec3d.zCoord, vec3d.xCoord) - Math.PI/2;
+            return Math.atan2(vec3.z, vec3.x) - Math.PI/2;
         }
     }
 
     @Override
-    public void onBlockAdded(World world, int x, int y, int z)
+    public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
         checkForHarden(world, x, y, z);
     }
@@ -265,19 +265,19 @@ public abstract class BlockFluid extends Block
                 int data = world.getBlockMetadata(x, y, z) & 0x0F;
                 if(data == 0)
                 {
-                    world.setBlockWithNotify(x, y, z, Block.obsidian.id);
+                    world.setBlockWithNotify(x, y, z, Blocks.OBSIDIAN.id);
                 }
                 else if(data <= 2)
                 {
-                    world.setBlockWithNotify(x, y, z, Block.cobbleGranite.id);
+                    world.setBlockWithNotify(x, y, z, Blocks.COBBLE_GRANITE.id);
                 }
                 else if(data <= 4)
                 {
-                    world.setBlockWithNotify(x, y, z, Block.cobbleStone.id);
+                    world.setBlockWithNotify(x, y, z, Blocks.COBBLE_STONE.id);
                 }
                 else
                 {
-                    world.setBlockWithNotify(x, y, z, Block.cobbleBasalt.id);
+                    world.setBlockWithNotify(x, y, z, Blocks.COBBLE_BASALT.id);
                 }
                 fizz(world, x, y, z);
             }
@@ -294,7 +294,7 @@ public abstract class BlockFluid extends Block
                 int data = world.getBlockMetadata(x, y, z) & 0x0F;
                 if(data == 0)
                 {
-                    world.setBlockWithNotify(x, y, z, Block.cobbleLimestone.id);
+                    world.setBlockWithNotify(x, y, z, Blocks.COBBLE_LIMESTONE.id);
                     fizz(world, x, y, z);
                 }
             }
@@ -302,7 +302,7 @@ public abstract class BlockFluid extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         return null;
     }
@@ -318,10 +318,10 @@ public abstract class BlockFluid extends Block
     @Override
     public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
-        float f7 = BlockFluid.getFluidHeight(world, x, y, z, blockMaterial);
-        float f8 = BlockFluid.getFluidHeight(world, x, y, z + 1, blockMaterial);
-        float f9 = BlockFluid.getFluidHeight(world, x + 1, y, z + 1, blockMaterial);
-        float f10 = BlockFluid.getFluidHeight(world, x + 1, y, z, blockMaterial);
+        float f7 = FluidBlock.getFluidHeight(world, x, y, z, blockMaterial);
+        float f8 = FluidBlock.getFluidHeight(world, x, y, z + 1, blockMaterial);
+        float f9 = FluidBlock.getFluidHeight(world, x + 1, y, z + 1, blockMaterial);
+        float f10 = FluidBlock.getFluidHeight(world, x + 1, y, z, blockMaterial);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, Math.max((f7 + f8 + f9 + f10)/4f, 0.2), 1.0F);
     }
 
@@ -343,10 +343,10 @@ public abstract class BlockFluid extends Block
                 int i2 = worldSource.getBlockMetadata(j1, y, l1);
                 if(i2 >= 8 || i2 == 0)
                 {
-                    f += BlockFluid.getWaterVolume(i2) * 10F;
+                    f += FluidBlock.getWaterVolume(i2) * 10F;
                     l += 10;
                 }
-                f += BlockFluid.getWaterVolume(i2);
+                f += FluidBlock.getWaterVolume(i2);
                 l++;
                 continue;
             }
diff --git a/src/main/java/net/minecraft/core/block/BlockFurnace.java b/src/main/java/net/minecraft/core/block/FurnaceBlock.java
similarity index 73%
rename from src/main/java/net/minecraft/core/block/BlockFurnace.java
rename to src/main/java/net/minecraft/core/block/FurnaceBlock.java
index 3c150634e..41a1327d2 100644
--- a/src/main/java/net/minecraft/core/block/BlockFurnace.java
+++ b/src/main/java/net/minecraft/core/block/FurnaceBlock.java
@@ -1,11 +1,11 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.Global;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityFurnace;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.FurnaceBlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
@@ -15,29 +15,29 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            BlockContainer, Material, Block, World, 
-//            IBlockAccess, TileEntityFurnace, EntityPlayer, TileEntity, 
-//            EntityLiving, MathHelper, IInventory, ItemStack, 
-//            EntityItem
+//            IBlockAccess, FurnaceBlockEntity, Player, BlockEntity,
+//            Mob, MathHelper, IInventory, ItemStack,
+//            ItemEntity
 
-public class BlockFurnace extends BlockTileEntityRotatable
+public class FurnaceBlock extends RotatableEntityBlock
 {
 
-	public BlockFurnace(String key, int id, boolean flag)
+	public FurnaceBlock(String key, String namespaceId, int id, boolean flag)
     {
-        super(key, id, Material.stone);
+        super(key, namespaceId, id, Material.stone);
         furnaceRand = new Random();
         isActive = flag;
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        super.onBlockAdded(world, x, y, z);
+        super.onBlockPlacedByWorld(world, x, y, z);
         setDefaultDirection(world, x, y, z);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -45,14 +45,14 @@ public class BlockFurnace extends BlockTileEntityRotatable
             case EXPLOSION:
             case PROPER_TOOL:
             case SILK_TOUCH:
-                return new ItemStack[] { new ItemStack(Block.furnaceStoneIdle) };
+                return new ItemStack[] { new ItemStack(Blocks.FURNACE_STONE_IDLE) };
             default:
                 return null;
         }
     }
 
     @Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+	public void animationTick(World world, int x, int y, int z, Random rand)
     {
         if(!isActive)
         {
@@ -87,10 +87,10 @@ public class BlockFurnace extends BlockTileEntityRotatable
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide) {
-            TileEntityFurnace tileentityfurnace = (TileEntityFurnace) world.getBlockTileEntity(x, y, z);
+            FurnaceBlockEntity tileentityfurnace = (FurnaceBlockEntity) world.getBlockEntity(x, y, z);
             player.displayGUIFurnace(tileentityfurnace);
         }
         return true;
@@ -98,7 +98,7 @@ public class BlockFurnace extends BlockTileEntityRotatable
 
 	public static void updateFurnaceBlockState(boolean lit, World world, int x, int y, int z) {
 		int meta = world.getBlockMetadata(x, y, z);
-		TileEntity tileentity = world.getBlockTileEntity(x, y, z);
+		BlockEntity tileentity = world.getBlockEntity(x, y, z);
 		if(tileentity == null) {
 			String msg = "Furnace is missing Tile Entity at x: "+x+" y: "+y+" z: "+z+", block will be removed!";
 			if(Global.BUILD_CHANNEL.isUnstableBuild()) {
@@ -110,9 +110,9 @@ public class BlockFurnace extends BlockTileEntityRotatable
 		}
 		keepFurnaceInventory = true;
 		if(lit) {
-			world.setBlockWithNotify(x, y, z, Block.furnaceStoneActive.id);
+			world.setBlockWithNotify(x, y, z, Blocks.FURNACE_STONE_ACTIVE.id);
 		} else {
-			world.setBlockWithNotify(x, y, z, Block.furnaceStoneIdle.id);
+			world.setBlockWithNotify(x, y, z, Blocks.FURNACE_STONE_IDLE.id);
 		}
 		keepFurnaceInventory = false;
 		world.setBlockMetadataWithNotify(x, y, z, meta);
@@ -121,9 +121,9 @@ public class BlockFurnace extends BlockTileEntityRotatable
 	}
 
     @Override
-	protected TileEntity getNewBlockEntity()
+	protected BlockEntity getNewBlockEntity()
     {
-        return new TileEntityFurnace();
+        return new FurnaceBlockEntity();
     }
     
     @Override
@@ -131,11 +131,11 @@ public class BlockFurnace extends BlockTileEntityRotatable
     {
         if(!keepFurnaceInventory)
         {
-            TileEntityFurnace tileentityfurnace = (TileEntityFurnace)world.getBlockTileEntity(x, y, z);
+            FurnaceBlockEntity tileentityfurnace = (FurnaceBlockEntity)world.getBlockEntity(x, y, z);
 label0:
-            for(int l = 0; l < tileentityfurnace.getSizeInventory(); l++)
+            for(int l = 0; l < tileentityfurnace.getContainerSize(); l++)
             {
-                ItemStack itemstack = tileentityfurnace.getStackInSlot(l);
+                ItemStack itemstack = tileentityfurnace.getItem(l);
                 if(itemstack == null)
                 {
                     continue;
@@ -155,7 +155,7 @@ label0:
                         i1 = itemstack.stackSize;
                     }
                     itemstack.stackSize -= i1;
-                    EntityItem entityitem = new EntityItem(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                    ItemEntity entityitem = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
                     float f3 = 0.05F;
                     entityitem.xd = (float)furnaceRand.nextGaussian() * f3;
                     entityitem.yd = (float)furnaceRand.nextGaussian() * f3 + 0.2F;
diff --git a/src/main/java/net/minecraft/core/block/BlockGlass.java b/src/main/java/net/minecraft/core/block/GlassBlock.java
similarity index 68%
rename from src/main/java/net/minecraft/core/block/BlockGlass.java
rename to src/main/java/net/minecraft/core/block/GlassBlock.java
index 8cfe5523a..a141ad72f 100644
--- a/src/main/java/net/minecraft/core/block/BlockGlass.java
+++ b/src/main/java/net/minecraft/core/block/GlassBlock.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -9,16 +9,16 @@ import net.minecraft.core.world.World;
 // Referenced classes of package net.minecraft.src:
 //            BlockBreakable, Material
 
-public class BlockGlass extends BlockTransparent
+public class GlassBlock extends TransparentBlock
 {
 
-    public BlockGlass(String key, int id, Material material)
+    public GlassBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/GlassDoorBlock.java b/src/main/java/net/minecraft/core/block/GlassDoorBlock.java
new file mode 100644
index 000000000..aba3110d3
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/GlassDoorBlock.java
@@ -0,0 +1,19 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+
+public class GlassDoorBlock extends DoorBlock {
+    public GlassDoorBlock(String key, String namespaceId, int id, Material material, boolean isTop) {
+        super(key, namespaceId, id, material, isTop);
+    }
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
+    {
+        return new ItemStack[] { new ItemStack(Items.DOOR_GLASS) };
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockGlowStone.java b/src/main/java/net/minecraft/core/block/GlowStoneBlock.java
similarity index 64%
rename from src/main/java/net/minecraft/core/block/BlockGlowStone.java
rename to src/main/java/net/minecraft/core/block/GlowStoneBlock.java
index 09d18b186..488425e41 100644
--- a/src/main/java/net/minecraft/core/block/BlockGlowStone.java
+++ b/src/main/java/net/minecraft/core/block/GlowStoneBlock.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
@@ -11,16 +11,16 @@ import net.minecraft.core.world.WorldSource;
 // Referenced classes of package net.minecraft.src:
 //            Block, Item, Material
 
-public class BlockGlowStone extends Block
+public class GlowStoneBlock extends Block
 {
 
-    public BlockGlowStone(String key, int id, Material material)
+    public GlowStoneBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -28,7 +28,7 @@ public class BlockGlowStone extends Block
             case SILK_TOUCH:
                 return new ItemStack[] { new ItemStack(this) };
             default:
-                return new ItemStack[] { new ItemStack(Item.dustGlowstone, 2 + world.rand.nextInt(2)) };
+                return new ItemStack[] { new ItemStack(Items.DUST_GLOWSTONE, 2 + world.rand.nextInt(2)) };
         }
     }
     
diff --git a/src/main/java/net/minecraft/core/block/BlockMeshGold.java b/src/main/java/net/minecraft/core/block/GoldMeshBlock.java
similarity index 54%
rename from src/main/java/net/minecraft/core/block/BlockMeshGold.java
rename to src/main/java/net/minecraft/core/block/GoldMeshBlock.java
index feac5ea56..989f44716 100644
--- a/src/main/java/net/minecraft/core/block/BlockMeshGold.java
+++ b/src/main/java/net/minecraft/core/block/GoldMeshBlock.java
@@ -1,23 +1,23 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityMeshGold;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.GoldMeshBlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class BlockMeshGold extends BlockTileEntity{
-    public BlockMeshGold(String key, int id) {
-        super(key, id, Material.metal);
+public class GoldMeshBlock extends EntityBlock {
+    public GoldMeshBlock(String key, String namespaceId, int id) {
+        super(key, namespaceId, id, Material.metal);
     }
 
     @Override
-    protected TileEntity getNewBlockEntity() {
-        return new TileEntityMeshGold();
+    protected BlockEntity getNewBlockEntity() {
+        return new GoldMeshBlockEntity();
     }
     @Override
     public boolean isSolidRender()
@@ -25,7 +25,7 @@ public class BlockMeshGold extends BlockTileEntity{
         return false;
     }
     @Override
-    public boolean renderAsNormalBlock()
+    public boolean isCubeShaped()
     {
         return false;
     }
@@ -36,37 +36,37 @@ public class BlockMeshGold extends BlockTileEntity{
         return true;
     }
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
-        TileEntityMeshGold meshGold = (TileEntityMeshGold) world.getBlockTileEntity(x, y, z);
+        GoldMeshBlockEntity meshGold = (GoldMeshBlockEntity) world.getBlockEntity(x, y, z);
         ItemStack heldItem = player.getHeldItem();
         boolean flag = meshGold.setFilterItem(player, heldItem);
         if(heldItem != null && heldItem.stackSize <= 0)
         {
-            player.inventory.setInventorySlotContents(player.inventory.currentItem, null);
+            player.inventory.setItem(player.inventory.currentItem, null);
         }
         return flag;
     }
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data) {
-        TileEntityMeshGold mesh = (TileEntityMeshGold) world.getBlockTileEntity(x, y, z);
+        GoldMeshBlockEntity mesh = (GoldMeshBlockEntity) world.getBlockEntity(x, y, z);
         if (mesh.filterItem != null){
-            EntityItem item = world.dropItem(x, y, z, mesh.filterItem);
+            ItemEntity item = world.dropItem(x, y, z, mesh.filterItem);
             item.xd *= 0.5;
             item.yd *= 0.5;
             item.zd *= 0.5;
-            item.delayBeforeCanPickup = 0;
+            item.pickupDelay = 0;
         }
         super.onBlockRemoved(world, x, y, z, data);
     }
 
     @Override
     public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
-        if (entity instanceof EntityItem){
-            TileEntityMeshGold mesh = (TileEntityMeshGold) world.getBlockTileEntity(x, y, z);
+        if (entity instanceof ItemEntity){
+            GoldMeshBlockEntity mesh = (GoldMeshBlockEntity) world.getBlockEntity(x, y, z);
             if (mesh.filterItem == null) return true;
 
-            ItemStack entityStack = ((EntityItem) entity).item;
+            ItemStack entityStack = ((ItemEntity) entity).item;
             return !entityStack.isItemEqual(mesh.filterItem);
         }
         return true;
diff --git a/src/main/java/net/minecraft/core/block/BlockOreGold.java b/src/main/java/net/minecraft/core/block/GoldOreBlock.java
similarity index 50%
rename from src/main/java/net/minecraft/core/block/BlockOreGold.java
rename to src/main/java/net/minecraft/core/block/GoldOreBlock.java
index b634fe48f..d94d39765 100644
--- a/src/main/java/net/minecraft/core/block/BlockOreGold.java
+++ b/src/main/java/net/minecraft/core/block/GoldOreBlock.java
@@ -1,20 +1,26 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
-public class BlockOreGold extends Block
-{
-    public BlockOreGold(String key, int id, Material material) {
-        super(key, id, material);
+import java.util.HashMap;
+import java.util.Map;
+
+
+public class GoldOreBlock extends Block {
+    public static Map<Integer, Integer> variantMap = new HashMap<>();
+
+    public GoldOreBlock(String key, String namespaceId, int id, int parentId, Material material) {
+        super(key, namespaceId, id, material);
+        variantMap.put(parentId, id);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -23,7 +29,7 @@ public class BlockOreGold extends Block
                 return new ItemStack[] { new ItemStack(this) };
             case EXPLOSION:
             case PROPER_TOOL:
-                return new ItemStack[] { new ItemStack(Item.oreRawGold) };
+                return new ItemStack[] { new ItemStack(Items.ORE_RAW_GOLD) };
             default:
                 return null;
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockGrass.java b/src/main/java/net/minecraft/core/block/GrassBlock.java
similarity index 75%
rename from src/main/java/net/minecraft/core/block/BlockGrass.java
rename to src/main/java/net/minecraft/core/block/GrassBlock.java
index 95f121127..5eb3065f4 100644
--- a/src/main/java/net/minecraft/core/block/BlockGrass.java
+++ b/src/main/java/net/minecraft/core/block/GrassBlock.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import java.util.Random;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.enums.EnumDropCause;
@@ -16,13 +16,13 @@ import net.minecraft.core.world.noise.ImprovedNoise;
 //            Block, Material, IBlockAccess, WorldChunkManager, 
 //            ColorizerGrass, World
 
-public class BlockGrass extends Block
+public class GrassBlock extends Block
 {
     private static ImprovedNoise grassColorPerlin = new ImprovedNoise(new Random(0));
 
-    public BlockGrass(String key, int id, Material material)
+    public GrassBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
         setTicking(true);
     }
 
@@ -39,7 +39,7 @@ public class BlockGrass extends Block
             {
                 return;
             }
-            world.setBlockWithNotify(x, y, z, Block.dirt.id);
+            world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
         } else
         if(world.getBlockLightValue(x, y + 1, z) >= 9)
         {
@@ -47,7 +47,7 @@ public class BlockGrass extends Block
             int i1 = (y + rand.nextInt(5)) - 3;
             int j1 = (z + rand.nextInt(3)) - 1;
             int k1 = world.getBlockId(l, i1 + 1, j1);
-            if(world.getBlockId(l, i1, j1) == Block.dirt.id && world.getBlockLightValue(l, i1 + 1, j1) >= 4 && Block.lightBlock[k1] <= 2)
+            if(world.getBlockId(l, i1, j1) == Blocks.DIRT.id && world.getBlockLightValue(l, i1 + 1, j1) >= 4 && Block.lightBlock[k1] <= 2)
             {
                 world.setBlockWithNotify(l, i1, j1, this.id);
             }
@@ -57,23 +57,23 @@ public class BlockGrass extends Block
                 int r = rand.nextInt(400);
 
                 if (r < 26) {
-                    idToSpawn = Block.flowerRed.id;
+                    idToSpawn = Blocks.FLOWER_RED.id;
                 } else if (r < 41) {
-                    idToSpawn = Block.flowerYellow.id;
+                    idToSpawn = Blocks.FLOWER_YELLOW.id;
                 } else if (r < 60) {
                     Biome biome = world.getBlockBiome(x, y + 1, z);
                     if (biome == Biomes.OVERWORLD_BIRCH_FOREST || biome == Biomes.OVERWORLD_SEASONAL_FOREST){
-                        idToSpawn = Block.flowerPink.id;
+                        idToSpawn = Blocks.FLOWER_PINK.id;
                     } else if (biome == Biomes.OVERWORLD_MEADOW || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_SHRUBLAND) {
-                        idToSpawn = Block.flowerPurple.id;
+                        idToSpawn = Blocks.FLOWER_PURPLE.id;
                     } else if (biome == Biomes.OVERWORLD_FOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_CAATINGA) {
-                        idToSpawn = Block.flowerLightBlue.id;
+                        idToSpawn = Blocks.FLOWER_LIGHT_BLUE.id;
                     }
                 } else {
                     if(rand.nextInt(8) == 0) {
-                        idToSpawn = Block.tallgrassFern.id;
+                        idToSpawn = Blocks.TALLGRASS_FERN.id;
                     }else {
-                        idToSpawn = Block.tallgrass.id;
+                        idToSpawn = Blocks.TALLGRASS.id;
                     }
                 }
 
@@ -83,7 +83,7 @@ public class BlockGrass extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -91,7 +91,7 @@ public class BlockGrass extends Block
             case PICK_BLOCK:
                 return new ItemStack[] { new ItemStack(this) };
             default:
-                return new ItemStack[] { new ItemStack(Block.dirt) };
+                return new ItemStack[] { new ItemStack(Blocks.DIRT) };
         }
     }
 }
